<?php

    include_once "./lib/comun.php";

    function cambioFormatoFecha($fecha) {
        if ($fecha != "") {
            $fecha = DateTime::createFromFormat("d/m/Y", $fecha);
            $fecha = $fecha->format("Y/m/d");
            return $fecha;
        }
    }

    function cambioFormatoFechaMenosUnDia($fecha) {
        if ($fecha != "") {
            $fecha = DateTime::createFromFormat("d/m/Y", $fecha);
            $fecha->sub(new DateInterval('PT24H'));
            $fecha = $fecha->format("Y/m/d");
            return $fecha;
        }
    }

    $fila = 1;
    if (($gestor = fopen("nuevas_fechas.csv", "r")) !== FALSE) {
        while (($datos = fgetcsv($gestor, 1000, ",")) !== FALSE) {
            $numero = count($datos);
            $fila++;
            $id = $datos[0];
            $fecha_entrada = cambioFormatoFecha($datos[1]);
            $fecha_salida = cambioFormatoFechaMenosUnDia($datos[2]);
            if (!($stmt = $mysqli->prepare("UPDATE reservaciones SET `fecha_entrada`=?, `fecha_salida`=? WHERE `id_reservacion`=?"))) {
                die(json_encode("Falló la preparación: (" . $mysqli->errno . ") " . $mysqli->error));
            }
            if (!$stmt->bind_param("ssi", $fecha_entrada, $fecha_salida, $id)) {
                die(json_encode("Falló la vinculación de parámetros: (" . $stmt->errno . ") " . $stmt->error));
            }
            if (!$stmt->execute()) {
                die(json_encode("Falló la ejecución: (" . $stmt->errno . ") " . $stmt->error));
            } else {
                echo "Actualizada: $id<br>";
                $stmt->close();
            }   
        }
        fclose($gestor);
    }