<?php
include 'lib/comun.php';
require_once('lib/convert.php');
require_once "./lib/fpdf185/fpdf.php";
$trans = new Latin1UTF8();
class PDF extends FPDF
{
	private $mysqli;

	function __construct($orientation, $unit, $size, $mysqli) 
  {
    parent::__construct($orientation, $unit, $size);
		$this->mysqli = $mysqli;
	}


	private function acentos($text) {
		return mb_convert_encoding($text, 'windows-1252', 'UTF-8');
	}

	function Header()
	{
		$q = "SELECT * FROM textos WHERE texto='titulo_evento'";
		$d = $this->mysqli->query($q);
		$r = $d->fetch_array();
		$titulo_evento = $r["es"];
		$q = "SELECT * FROM textos WHERE texto='lugar'";
		$d = $this->mysqli->query($q);
		$r = $d->fetch_array();
		$lugar = $r["es"];
		$this->SetFont("Arial", "B", 14);
		$this->Cell(50, 10, strtoupper($titulo_evento));
		$this->Image('img/intermeeting.jpg', 230, 10, 50);
		$this->Ln();
		$this->SetFont("Arial", "B", 12);
		$this->Cell(270, 10, $this->acentos("ROOMING EMPRESA - Alfabético"), 0, 0, "C");
		$this->Ln();
		$this->SetFont("Arial", "", 8);
		$this->Cell(150, 10, "$lugar");
		$this->Cell(20, 10, date("Y-m-d"));
		$this->Ln();
		$this->Cell(270, 0, "", 1);
		$this->Ln();
	}
	//Page footer
	function Footer()
	{
		$this->SetY(-15);
		$this->SetFont('Arial', '', 6);
		$this->Cell(250, 10, 'International Meeting Services, S.A. de C.V. Eje 10 Sur Av. Río de la Magdalena No. 326, Col. La Otra Banda. Oficinas 201 a 202. Tels: 52 (55) 5663-2803 / 5663-0402', 0, 0, '');
		$this->Cell(0, 10, 'Pag: ' . $this->PageNo() . '/{nb}', 0, 0, '');
	}
}
$empresa = $_GET["empresa"];
$q = "SELECT DATEDIFF(max(fecha_salida) + INTERVAL 1 DAY,min(fecha_entrada) - INTERVAL 1 DAY) AS cuantas,min(fecha_entrada) - INTERVAL 1 DAY AS inicio,max(fecha_salida) + INTERVAL 1 DAY  AS fin FROM reservaciones
	WHERE fecha_entrada<>'1970-01-01 00:00:01' AND  fecha_salida<>'1970-01-01 00:00:01'";
$d = $mysqli->query($q);
$r = $d->fetch_array();
$cuantas = $r["cuantas"];
$inicio = $r["inicio"];
$fin = $r["fin"];
$pdf = new PDF("L", "mm", "Letter", $mysqli);
$pdf->AliasNbPages();
$pdf->AddPage();
$pdf->SetFont("Arial", "B", 16);
$pdf->Cell(50, 10, "Empresa: $empresa");
$pdf->Ln();
$q = "SELECT distinct hotel FROM reservaciones 
LEFT JOIN hoteles ON hoteles.id_hotel=reservaciones.id_hotel
WHERE empresa='$empresa'
ORDER BY hotel";
$d = $mysqli->query($q);
while ($r = $d->fetch_array()) {
	$hotel = $r["hotel"];
	$pdf->SetFont("Arial", "B", 12);
	$pdf->Cell(50, 10, "Hotel: " . $hotel);
	$pdf->Ln();
	$pdf->SetFont("Arial", "B", 6);
	$pdf->Cell(60, 8, "Nombre", 1);
	$pdf->Cell(20, 8, "Clave", 1);
	$pdf->Cell(60, 8, "Habitacion", 1);
	$pdf->Cell(20, 8, "Costo", 1);
	$pdf->Cell(20, 8, "Noches", 1);
	$pdf->Cell(20, 8, "Importe", 1);
	for ($i = 1; $i < $cuantas; $i++) {
		$date = strtotime("+" . $i . " days", strtotime($inicio));
		$date =  date("d", $date);
		$pdf->Cell(7, 8, $date, 1);
	}
	$pdf->Ln();
	$query = "SELECT abreviatura,id_reservacion,empresa, paterno,materno,nombre,acompanante,hotel,habitacion,precio,fecha_entrada,DATE_ADD(fecha_salida, INTERVAL 1 DAY) AS salida, fecha_salida AS salidaoriginal,DATEDIFF(DATE_ADD(fecha_salida, INTERVAL 1 DAY),fecha_entrada) AS noches,(DATEDIFF(DATE_ADD(fecha_salida, INTERVAL 1 DAY),fecha_entrada)*precio) AS importe,(DATEDIFF(DATE_ADD(fecha_salida, INTERVAL 1 DAY),fecha_entrada)*precio)*1.16 AS importemasiva,(DATEDIFF(DATE_ADD(fecha_salida, INTERVAL 1 DAY),fecha_entrada)*precio)-((DATEDIFF(DATE_ADD(fecha_salida, INTERVAL 1 DAY),fecha_entrada)*precio)*0.16) AS importemenosiva,nocamas,requerimientos  FROM reservaciones
			LEFT JOIN hoteles ON hoteles.id_hotel=reservaciones.id_hotel
			LEFT JOIN habitaciones ON habitaciones.id_habitacion=reservaciones.id_habitacion
			LEFT JOIN precios ON precios.id_hotel=reservaciones.id_hotel AND precios.id_habitacion=reservaciones.id_habitacion
			LEFT JOIN enum ON enum.id_enumeracion=reservaciones.id_enumeracion
			WHERE empresa='$empresa' AND hotel='$hotel'
			ORDER BY paterno,materno,nombre";
	// echo $query."<br><br>";
	$result = $mysqli->query($query);
	$habitaciones = 0;
	$noches = 0;
	$total = 0;
	$iva = 0;
	$subtotal = 0;
	//$totalglobal=0;
	//$subtotalglobal=0;
	while ($row = $result->fetch_array()) {
		$habitaciones++;
		$importe = $row["importe"];
		$noches = $noches + $row["noches"];
		$subtotal = $subtotal + ((round($row["precio"] / 1.16, 2)) * $row["noches"]);
		$iva = $iva + ((round($row["precio"] / 1.16, 2)) * $row["noches"]) * 0.16;
		$pdf->SetFont("Arial", "", 6);
		$pdf->Cell(60, 4, $row["paterno"] . " " . $row["materno"] . " " . $row["nombre"], 1);
		$pdf->Cell(20, 4, $row["id_reservacion"], 1);
		$pdf->Cell(60, 4, $row["habitacion"], 1);
		$pdf->Cell(20, 4, "$" . number_format($row["precio"] / 1.16, 2), 1, 0, "R");
		$pdf->Cell(20, 4, $row["noches"], 1);
		$pdf->Cell(20, 4, "$" . number_format(($row["precio"] / 1.16) * $row["noches"], 2), 1, 0, "R");
		for ($i = 1; $i < $cuantas; $i++) {
			$date = strtotime("+" . $i . " days", strtotime($inicio));
			$date =  date("Y-m-d", $date);
			$today = strtotime($date);
			$fromdate = strtotime($row["fecha_entrada"]);
			$todate = strtotime($row["salidaoriginal"]);
			if ($today >= $fromdate && $today <= $todate) {
				//$pdf->Cell(5,4,substr($row["habitacion"],0,3),1);
				$pdf->Cell(7, 4, $row["abreviatura"], 1);
			} else {
				$pdf->Cell(7, 4, "", 1);
			}
		}
		$pdf->Ln();
	}
	$pdf->Ln();
	$pdf->SetFont("Arial", "", 6);
	$pdf->Cell(40, 8, "Total: " . $habitaciones . " habitaciones en el Hotel " . "$hotel");
	$pdf->Ln();
	$pdf->Cell(40, 8, "Noches: $noches");
	$pdf->Cell(40, 8, "Subtotal: $" . number_format($subtotal, 2));
	$pdf->Cell(40, 8, "IVA: $" . number_format($iva, 2));
	$total = $subtotal + $iva;
	$pdf->Cell(40, 8, "Total: $" . number_format($total, 2));
	$pdf->Ln();
	$pdf->Cell(270, 0, "", 1);
	$pdf->Ln();
	$habitacionesglobal = $habitacionesglobal + $habitaciones;
	$nochesglobal = $nochesglobal + $noches;
	$subtotalglobal = $subtotalglobal + $subtotal;
	$ivaglobal = $ivaglobal + $iva;
	$totalglobal = $totalglobal + $total;
}
$pdf->SetFont("Arial", "B", 12);
$pdf->Cell(60, 8, "Total: $habitacionesglobal habitaciones solicitadas por  $empresa");
$pdf->Ln();
$pdf->Cell(60, 8, "Noches: $nochesglobal");
$pdf->Cell(60, 8, "Subtotal: $" . number_format($subtotalglobal, 2));
$pdf->Cell(60, 8, "IVA: $" . number_format($ivaglobal, 2));
$pdf->Cell(60, 8, "Total: $" . number_format($totalglobal, 2));
$pdf->Ln();
$pdf->Output("Estado de Cuenta $empresa ($titulo_evento).pdf", "D");
