<?

/**
 * Archivo que contiene funciones, utilerían y la conexión a la base de datos.
 * 
 * Este archivo es requerido por index.php
 * 
 * Ruta:
 * .
 * |-- lib
 */
/**
 * Función que obtiene la ip del cliente.
 * @param void
 * @return string ip del cliente.
 */
function get_client_ip()
{
	$ipaddress = '';
	if ($_SERVER['HTTP_CLIENT_IP'])
		$ipaddress = $_SERVER['HTTP_CLIENT_IP'];
	else if ($_SERVER['HTTP_X_FORWARDED_FOR'])
		$ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
	else if ($_SERVER['HTTP_X_FORWARDED'])
		$ipaddress = $_SERVER['HTTP_X_FORWARDED'];
	else if ($_SERVER['HTTP_FORWARDED_FOR'])
		$ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
	else if ($_SERVER['HTTP_FORWARDED'])
		$ipaddress = $_SERVER['HTTP_FORWARDED'];
	else if ($_SERVER['REMOTE_ADDR'])
		$ipaddress = $_SERVER['REMOTE_ADDR'];
	else
		$ipaddress = 'UNKNOWN';
	return $ipaddress;
}
// Se obtiene la ip del cliente.
$ip = get_client_ip();
// En caso de que la ip del cliente se encuentre en esta lista, se terminará la ejecución del sistema.s
if ($ip == "31.6.35.106"  || $ip == "95.211.188.51" || $ip == "77.247.181.162" || $ip == "81.7.8.101" || $ip == "95.169.190.104" || $ip == "94.126.178.1" || $ip == "94.242.246.24" || $ip == "46.165.223.217" || $ip == "37.187.129.166" || $ip == "212.21.66.6" || $ip == "31.31.78.141" || $ip == "178.175.139.141" || $ip == "89.105.194.68" || $ip == "35.0.127.52" || $ip == "96.47.226.21" || $ip == "94.103.175.86" || $ip == "89.234.157.254" || $ip == "166.70.207.2" || $ip == "188.138.17.15" || $ip == "172.98.66.75") {
	die();
}
// Inicia session
session_start();
/**
 * Conexión a la base de datos.
 * 
 * mysql ha sido deprecated en las últimas versiones de php,
 * se recomienda en futuras versiones actualizar a mysqli o PDO.
 * 
 */

$mysqli = new mysqli("localhost", "imsonlinemx_admin", "m46w5hQWrdRqLBS", "imsonlinemx_res_hyc_2025");
if ($mysqli->connect_errno) {
	echo "Fallo al conectar a MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
}
$mysqli->set_charset('utf8');

/**
 * Se inicializan variables de idioma.
 * 
 * El idioma actual es obtenido mediante el query string idioma.
 * 
 * @var string $idioma almacena el identificador del idioma actual del sistema.
 * 			   Puede contener los siguiente valores:
 * 			   es para español
 * 			   en para inglés
 * 			   pt para portugués (deprecated)
 * @var string $sufijo almacena el sufijo del idioma actual del sistema,
 *             se utiliza principalmente al obtener textos o datos de la base de datos
 * 			   en el idioma actual del sistema.
 * 			   Puede contener los siguiente valores:
 * 			   "" (cadena de caracteres vacía) para español
 * 			   _en para inglés
 * 			   _pt para portugués (deprecated)
 */
if ($_GET["idioma"] == "es") {
	$idioma = "es";
	$sufijo = "";
}
/**
 * @deprecated 1.1
 * El idioma portugués ya no se utiliza.
 */
if ($_GET["idioma"] == "pt") {
	$idioma = "pt";
	$sufijo = "_pt";
}
if ($_GET["idioma"] == "en") {
	$idioma = "en";
	$sufijo = "_en";
}
/**
 * Si se desea que el idioma por defecto del sistema sea inglés, modificará el siguiente if
 * como se muestra a continuación.
 * 
 * if ($_POST["idioma"]=="en" || $_GET["idioma"]=="") {
 * 		$idioma="en";
 * 		$sufijo="_en";
 * }
 */
if ($_POST["idioma"] == "es" || $_GET["idioma"] == "") {
	$idioma = "es";
	$sufijo = "";
}
/**
 * @deprecated 1.1
 * El idioma portugués ya no se utiliza.
 */
if ($_POST["idioma"] == "pt") {
	$idioma = "pt";
	$sufijo = "_pt";
}
/**
 * Si se desea que el idioma por defecto del sistema sea inglés, modificará el siguiente if
 * como se muestra a continuación.
 * 
 * if ($_POST["idioma"]=="es) {
 * 		$idioma="es";
 * 		sufijo="";
 * }
 */
if ($_POST["idioma"] == "en") {
	$idioma = "en";
	$sufijo = "_en";
}
/**
 * Obtiene de la base de datos, tabla textos, los textos que se utilizan en todo el sistema.
 * Estos son almacenados en variables con el mismo nombre que el campo de la base de datos.
 * 
 * Ej: 	Texto				Variable
 * 		titulo_evento		$titulo_evento
 * 		moneda				$moneda
 * 
 */
$query = "SELECT * FROM textos";
$result = $mysqli->query($query);
while ($row = $result->fetch_array()) {
	${$row["texto"]} = $row[$idioma];
}
/**
 * Funcion que encripta texto.
 * @deprecated 1.1 Esta función se utilizaba para encriptar los números de tarjetas,
 * 			   en la versión del sistema sin VPOS.
 * @param string $str 	Texto a encriptar
 * @param string $ky	Llave para encriptar
 * @return string	Texto encriptado
 */
function encriptar($str, $ky = '')
{
	if ($ky == '') return $str;
	$ky = str_replace(chr(32), '', $ky);
	if (strlen($ky) < 8) exit('key error');
	$kl = strlen($ky) < 32 ? strlen($ky) : 32;
	$k = array();
	for ($i = 0; $i < $kl; $i++) {
		$k[$i] = ord($ky[$i]) & 0x1F;
	}
	$j = 0;
	for ($i = 0; $i < strlen($str); $i++) {
		$e = ord($str[$i]);
		$str[$i] = $e & 0xE0 ? chr($e ^ $k[$j]) : chr($e);
		$j++;
		$j = $j == $kl ? 0 : $j;
	}
	$str = str_replace("'", "apostrofe", $str);
	$str = str_replace("\"", "comilla", $str);
	$str = str_replace("\\", "escape", $str);
	return $str;
}
/**
 * Funcion que desencripta texto.
 * @deprecated 1.1 Esta función se utilizaba para desencriptar los números de tarjetas,
 * 			   en la versión del sistema sin VPOS.
 * @param string $str 	Texto a desencriptar
 * @param string $ky	Llave para desencriptar
 * @return string	Texto desencriptado
 */
function desencriptar($str, $ky = '')
{
	$str = str_replace("apostrofe", "'", $str);
	$str = str_replace("comilla", "\"", $str);
	$str = str_replace("escape", "\\", $str);
	if ($ky == '') return $str;
	$ky = str_replace(chr(32), '', $ky);
	if (strlen($ky) < 8) exit('key error');
	$kl = strlen($ky) < 32 ? strlen($ky) : 32;
	$k = array();
	for ($i = 0; $i < $kl; $i++) {
		$k[$i] = ord($ky[$i]) & 0x1F;
	}
	$j = 0;
	for ($i = 0; $i < strlen($str); $i++) {
		$e = ord($str[$i]);
		$str[$i] = $e & 0xE0 ? chr($e ^ $k[$j]) : chr($e);
		$j++;
		$j = $j == $kl ? 0 : $j;
	}
	return $str;
}
/** 
 * Llave utilizada para encriptar y desencriptar textos
 * @deprecated 1.1 Esta función se utilizaba para desencriptar los números de tarjetas,
 * 			   en la versión del sistema sin VPOS.
 */
$llave = "TTJ4M2M0eDJM";
